--xItem Lib
--modular custom item library
--written by minenice
--don't expect this to be compatible with vanilla replays you fuck

local currLibVer = 4

--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_driftcharge = k_driftcharge
	
--item flags
local XIF_POWERITEM = 1 --is power item
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_UNIQUEANDUSED = 8 --same as unique, but also checks item timers (vanilla hyu specific: check hyubgone)
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --set hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount

--item constants
--base game items are always KITEM_ (real item) or KRITEM_ (roulette-facing only)
local xItems = {
	KITEM_SAD = -1,
	KITEM_NONE = 0,
	KITEM_SNEAKER = 1,
	KITEM_ROCKETSNEAKER = 2,
	KITEM_INVINCIBILITY = 3,
	KITEM_BANANA = 4,
	KITEM_EGGMAN = 5,
	KITEM_ORBINAUT = 6,
	KITEM_JAWZ = 7,
	KITEM_MINE = 8,
	KITEM_BALLHOG = 9,
	KITEM_SPB = 10,
	KITEM_GROW = 11,
	KITEM_SHRINK = 12,
	KITEM_THUNDERSHIELD = 13,
	KITEM_HYUDORO = 14,
	KITEM_POGOSPRING = 15,
	KITEM_KITCHENSINK = 16,

	--Additional roulette numbers, only used for K_KartGetItemResult
	KRITEM_TRIPLESNEAKER = 17,
	KRITEM_TRIPLEBANANA = 18,
	KRITEM_TENFOLDBANANA = 19,
	KRITEM_TRIPLEORBINAUT = 20,
	KRITEM_QUADORBINAUT = 21,
	KRITEM_DUALJAWZ = 22
}

local function addItemPatch(item, bigpatch, smallpatch)
	local t = {}
	if type(bigpatch) == "string" then
		t.bigTics = false
		t.bigP = bigpatch
	elseif type(bigpatch) == "table" then
		t.bigTics = bigpatch[1]
		t.bigP = {}
		for i = 2, #bigpatch do
			table.insert(t.bigP, bigpatch[i])
		end
	end
	if type(smallpatch) == "string" then
		t.smallTics = false
		t.smallP = smallpatch
	elseif type(smallpatch) == "table" then
		t.smallTics = smallpatch[1]
		t.smallP = {}
		for i = 2, #smallpatch do
			table.insert(t.smallP, smallpatch[i])
		end
	end
	xItemLib.xItemPatch[item] = t
end

local function getLoadedItemAmount()
	return table.maxn(xItemLib.xItems) - 2
end

local function getItemPatch(item, small)
	local t = xItemLib.xItemPatch[item]
	if small then
		return t.smallTics, (t.smallP or "K_ISSAD")
	else
		return t.bigTics, (t.bigP or "K_ITSAD")
	end
end

local function addXItem(namespace, iName, bigpatch, smallpatch, flags, raceodds, battleodds, getfunc, usefunc, hudfunc, oddsfunc, resultfunc, droppedstate)
	local item = xItemLib.func.countItems() + 1
	if type(namespace) ~= "table" then
		if type(namespace) ~= "string" then
			error("Tried to add item "..item..", first argument isn't a string", 2)
		end
	else
		namespace, iName, bigpatch, smallpatch, flags, raceodds, battleodds, getfunc, usefunc, hudfunc, oddsfunc, resultfunc, droppedstate = unpack(namespace, 1, 13)
		if type(namespace) ~= "string" then
			error("Tried to add item "..item..", first element in the passed table isn't a string", 2)
		end
	end
	table.insert(xItemLib.xItems, item)
	xItemLib.xItemNamespaces[namespace] = item
	xItemLib.func.setPatch(item, bigpatch or "K_ITSAD", smallpatch or "K_ISSAD")
	if flags then
		xItemLib.xItemFlags[item] = flags
	end
	--default odds are nothing
	table.insert(xItemLib.xItemOddsRace, raceodds or {0, 0, 0, 0, 0, 0, 0, 0, 0, 0})
	table.insert(xItemLib.xItemOddsBattle, battleoddsodds or {0, 0})
	xItemLib.xItemData[item] = {
		name = iName, --can be used in other mods
		defaultRaceOdds = raceodds or {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		defaultBattleOdds = battleodds or {0, 0},
		getfunc = getfunc or nil,
		usefunc = usefunc or nil,
		hudfunc = hudfunc or nil,
		oddsfunc = oddsfunc or nil,
		resultfunc = resultfunc or nil,
		droppedstate = droppedstate or S_NULL,
	}
	print("added item "..item.." named "..namespace.." to xItems")
	print(xItemLib.func.countItems().." items are loaded ("..table.maxn(xItemLib.xItemPatch).." patch entries)")
end



local function resetOddsForItem(item, p, battle)
	local dat = p.xItemData
	local i = item
	if type(item) == "string" then --item namespace
		i = xItemLib.xItemNamespaces[item]
		if not i then
			print("can't find item "..item)
			return
		end
	end
	
	if battle then
		dat.xItem_battleOdds[i] = xItemLib.xItemData[i].defaultBattleOdds
	else
		dat.xItem_raceOdds[i] = xItemLib.xItemData[i].defaultRaceOdds
	end
end



local starttime = 6*TICRATE + (3*TICRATE/4)



local function playerScaling(spbrush, playersInGame)
	return (8 - (spbrush and 2 or playersInGame))
end



local function checkStartCooldown()
	return (leveltime < (30*TICRATE)+starttime)
end



local function checkPowerItemOdds(odds, mashed, spbrush, playersInGame)
	if (franticitems) then
		odds = $ << 1
	end
	odds = FixedMul($ << FRACBITS, FRACUNIT + ((xItemLib.func.getPlayerScaling(spbrush, playersInGame) << FRACBITS) / 25)) >> FRACBITS
	if (mashed > 0) then
		odds = FixedDiv(odds << FRACBITS, FRACUNIT + mashed) >> FRACBITS
	end
	return odds
end



local function floatingItemThinker(mo)
	if mo and mo.valid and mo.threshold > 22 then
		local i = mo.threshold
		if xItemLib.xItemData[i] and xItemLib.xItemData[i].droppedstate then
			mo.state = xItemLib.xItemData[i].droppedstate
		else
			mo.state = S_NULL
		end
	end
end


local function xItem_GetItemResult(p, getitem)
	if (getitem == xItems.KITEM_SPB or getitem == xItems.KITEM_SHRINK) then
		K_SetIndirectItemCooldown(20*TICRATE)
	end
	if (getitem == xItems.KITEM_HYUDORO)
		K_SetHyudoroCooldown(5*TICRATE)
	end
	-- Special roulettes first, then the generic ones are handled by default
	if getitem == xItems.KRITEM_TRIPLESNEAKER then
		p.kartstuff[k_itemtype] = xItems.KITEM_SNEAKER
		p.kartstuff[k_itemamount] = 3
	elseif getitem == xItems.KRITEM_TRIPLEBANANA then
		p.kartstuff[k_itemtype] = xItems.KITEM_BANANA
		p.kartstuff[k_itemamount] = 3
	elseif getitem == xItems.KRITEM_TENFOLDBANANA then
		p.kartstuff[k_itemtype] = xItems.KITEM_BANANA
		p.kartstuff[k_itemamount] = 10
	elseif getitem == KRITEM_TRIPLEORBINAUT then
		p.kartstuff[k_itemtype] = xItems.KITEM_ORBINAUT
		p.kartstuff[k_itemamount] = 3
	elseif getitem == xItems.KRITEM_QUADORBINAUT then
		p.kartstuff[k_itemtype] = xItems.KITEM_ORBINAUT
		p.kartstuff[k_itemamount] = 4
	elseif getitem == xItems.KRITEM_DUALJAWZ then
		p.kartstuff[k_itemtype] = xItems.KITEM_JAWZ
		p.kartstuff[k_itemamount] = 2
	elseif xItemLib.xItemData[getitem] and xItemLib.xItemData[getitem].resultfunc then
		p.kartstuff[k_itemtype], p.kartstuff[k_itemamount] = xItemLib.xItemData[getitem].resultfunc(p, getitem)
	else
		if (getitem <= 0 or getitem > xItemLib.func.countItems()) then -- Sad (Fallback)
			if (getitem ~= 0) then
				print("ERROR: xItem_GetItemResult - Item roulette gave bad item "..getitem.." :(")
			end
			p.kartstuff[k_itemtype] = xItems.KITEM_SAD
		else
			p.kartstuff[k_itemtype] = getitem
		end
		p.kartstuff[k_itemamount] = 1
	end
end



local function xItem_GetOdds(pos, item, mashed, spbrush, p)
	local distvar = 64*14
	local newodds
	local disabledItems = {}
	local pingame, pexiting = 0, 0
	--thunderisout follows UNIQUE
	local first, second
	local secondist = 0
	local oddsTable = {}
	
	if item <= 0 then return 0 end
	
	--if player itemodds doesn't exist for some reason fallback to the global itemodds
	if (G_BattleGametype()) then
		oddsTable = p.xItemData.xItem_battleOdds or xItemLib.xItemOddsBattle
	else
		oddsTable = p.xItemData.xItem_raceOdds or xItemLib.xItemOddsRace
	end
	
	--TODO: item toggle cvars
	--print("getting odds for item "..item.." at pos "..pos)
	
	newodds = oddsTable[item][pos] * 4
	
	--print("got odds "..newodds)
	
	for p in players.iterate do
		if p.spectator then continue end
		if not G_BattleGametype() or p.kartstuff[k_bumper] then pingame = $+1 end
		if p.exiting or (p.pflags and PF_TIMEOVER) then pexiting = $+1 end
		if p.mo then
			local iFlags = xItemLib.xItemFlags[p.kartstuff[k_itemtype]]
			if iFlags and (iFlags & XIF_UNIQUE) then
				disabledItems[p.kartstuff[k_itemtype]] = true
			end
			if (not G_BattleGametype()) then
				if (p.kartstuff[k_position] == 1 and first == -1)
					first = p
				end
				if (p.kartstuff[k_position] == 2 and second == -1)
					second = p
				end
			end
		end
	end
	if (first and second) then
		local p1 = first.mo
		local p2 = second.mo
		secondist = R_PointToDist2(0, p1.x, R_PointToDist2(p1.y, p1.z, p2.y, p2.z), p2.x) / mapobjectscale
		if (franticitems) then
			secondist = (15 * $) / 14
		end
		secondist = ((28 + (8-pingame)) * $) / 28
	end
	
	--replaces the switch-case with a table of flags, for modularity
	local iFlags = xItemLib.xItemFlags[item]
	if iFlags then
		if (iFlags & XIF_POWERITEM) then
			newodds = xItemLib.func.getPowerOdds($, mashed, spbrush, pingame)
		end
		if (iFlags & XIF_COOLDOWNINDIRECT) then
			if indirectitemcooldown then newodds = 0 end
		end
		if (iFlags & XIF_UNIQUE) then
			if disabledItems[item] then newodds = 0 end
		end
		if (iFlags & XIF_COOLDOWNONSTART) then
			if xItemLib.func.getStartCountdown() then newodds = 0 end
		end
	end
	
	--special vanilla cases
	if item == xItems.KITEM_SPB then
		if ((indirectitemcooldown or pexiting > 0 or secondist/distvar < 3) and (pos ~= 10)) then -- Force SPB
			newodds = 0
		else
			newodds = $ * min((secondist/distvar)-4, 3)
		end
	elseif item == xItems.KITEM_SHRINK then
		if (indirectitemcooldown > 0) or (pingame-1 <= pexiting) then
			newodds = 0
		end
	end
	
	--special cases, custom items
	if xItemLib.xItemData[item] and xItemLib.xItemData[item].oddsfunc then
		newodds = xItemLib.xItemData[item].oddsfunc(newodds, pos, mashed, spbrush, p) or $
	end
	--print("got final odds "..newodds)
	return newodds or 0
end



local function setupDistTable(odds, num, disttable, distlen)
	local a = 0
	for i = num, 1, -1 do
		disttable[distlen + a] = odds
		a = $+1
	end
	return a
end



local function xItem_FindUseOdds(p, mashed, pingame, spbrush, dontforcespb)
	local distvar = 64*14
	local i
	local pdis = 0
	local useodds = 1
	local oddsvalid = {}
	local disttable = {}
	local distlen = 0
	
	local FAUXPOS = G_BattleGametype() and 2 or 10
	
	--make faux positions valid or not
	for i = 1, FAUXPOS do
		local available = false
		--TODO: replace with max xItem index
		for j = 1, xItemLib.func.countItems() do
			--print("checking itemodds for item "..j.." at pos "..i)
			if xItemLib.func.getOdds(i, j, mashed, spbrush, p) > 0 then
				available = true
				if j > 22 then
					--print("item "..j.." is available for pos "..i)
				end
				break
			end
		end
		oddsvalid[i] = available
	end
	
	--calc distances (honestly kinda weiiiirdddd)
	for p2 in players.iterate do
		if p.mo and p2 and (not p2.spectator) and p2.mo and p2.kartstuff[k_position] < p.kartstuff[k_position] then
			pdis = $ + R_PointToDist2(0, p.mo.x, R_PointToDist2(p.mo.y, p.mo.z, p2.mo.y, p2.mo.z), p2.mo.x) / mapobjectscale * (pingame - p2.kartstuff[k_position]) / max(1, ((pingame - 1) * (pingame + 1) / 3))
		end
	end
	
	--set up distributions
	if (G_BattleGametype()) then
		if (p.kartstuff[k_roulettetype] == 1 and oddsvalid[2])
			-- 1 is the extreme odds of player-controlled "Karma" items
			useodds = 2
		else
			useodds = 1
			if (oddsvalid[1] == false and oddsvalid[2])
				-- try to use karma odds as a fallback
				useodds = 2
			end
		end
	else
		if oddsvalid[2] then distlen = $ + xItemLib.func.setupDist(2, 1, disttable, distlen) end
		if oddsvalid[3] then distlen = $ + xItemLib.func.setupDist(3, 1, disttable, distlen) end
		if oddsvalid[4] then distlen = $ + xItemLib.func.setupDist(4, 1, disttable, distlen) end
		if oddsvalid[5] then distlen = $ + xItemLib.func.setupDist(5, 2, disttable, distlen) end
		if oddsvalid[6] then distlen = $ + xItemLib.func.setupDist(6, 2, disttable, distlen) end
		if oddsvalid[7] then distlen = $ + xItemLib.func.setupDist(7, 3, disttable, distlen) end
		if oddsvalid[8] then distlen = $ + xItemLib.func.setupDist(8, 3, disttable, distlen) end
		if oddsvalid[9] then distlen = $ + xItemLib.func.setupDist(9, 1, disttable, distlen) end
		
		if (franticitems) then -- Frantic items make the distances between everyone artifically higher, for crazier items
			pdis = (15 * $) / 14
		end
		
		if (spbrush) -- SPB Rush Mode: It's 2nd place's job to catch-up items and make 1st place's job hell
			pdis = (3 * $) / 2
		end
		
		pdis = ((28 + (8-pingame)) * $) / 28
		
		if pingame == 1 and oddsvalid[1] then					-- Record Attack, or just alone
			useodds = 1
			--print("in RA")
		elseif pdis <= 0 then									-- (64*14) *  0 =     0
			--print(disttable[1])
			useodds = disttable[1] - 1
		elseif p.kartstuff[k_position] == 2 and pdis > distvar*6 and spbplace == -1 and (not indirectitemcooldown) and (not dontforcespb) and oddsvalid[10] then -- Force SPB in 2nd
			useodds = 10
		elseif pdis > distvar * ((12 * distlen) / 14) then -- (64*14) * 12 = 10752
			useodds = disttable[distlen-1]
		else
			for i = 1, 12 do
				if pdis <= distvar * ((i * distlen) / 14) then
					--print(((i * distlen) / 14))
					useodds = disttable[((i * distlen) / 14) + 1] - 1
					break
				end
			end
		end
	end
	--print(useodds)
	--print("Got useodds "..useodds.." (kart useodds "..(useodds - 1).."). (position: "..p.kartstuff[k_position]..", distance: "..pdis..")")
	return useodds
end

local function xItem_ItemRoulette(p, cmd)
	local i
	local pingame = 0
	local roulettestop
	local useodds = 0
	local spawnchance = {}
	local totalspawnchance = 0
	local bestbumper = 0
	local mashed = 0
	local dontforcespb = false
	local spbrush = false
	
	if leveltime == 0 then
		p.xItemData.xItem_roulette = 0
	end
	if p.kartstuff[k_itemroulette] and p.xItemData.xItem_roulette == 0 then
		p.xItemData.xItem_roulette = p.kartstuff[k_itemroulette]
		p.kartstuff[k_itemroulette] = 0
	end
	if p.kartstuff[k_itemroulette] and (p.kartstuff[k_roulettetype] == 2) then
		p.kartstuff[k_itemroulette] = 0
	end
	
	if p.xItemData.xItem_roulette then
		p.xItemData.xItem_roulette = $+1
	else
		return
	end
	
	-- Gotta check how many players are active at this moment.
	for p in players.iterate do
		if p.spectator then continue end
		pingame = $+1
		if (p.exiting) then
			dontforcespb = true
		end
		if (p.kartstuff[k_bumper] > bestbumper)
			bestbumper = p.kartstuff[k_bumper]
		end
	end
	if (pingame <= 2)
		dontforcespb = true
	end
	
	-- This makes the roulette produce the random noises.
	if p.xItemData.xItem_roulette % 3 == 1 then
		S_StartSound(nil, sfx_itrol1 + ((p.xItemData.xItem_roulette / 3) % 8), p)
	end
	
	--print("roulette tic "..p.xItemData.xItem_roulette)
	roulettestop = TICRATE + (3*(pingame - p.kartstuff[k_position]))
	if ((cmd.buttons & BT_ATTACK) and not (p.kartstuff[k_eggmanheld] or p.kartstuff[k_itemheld]) and p.xItemData.xItem_roulette >= roulettestop and not modeattacking) then
		-- Mashing reduces your chances for the good items
		mashed = FixedDiv(p.xItemData.xItem_roulette*FRACUNIT, ((TICRATE*3)+roulettestop)*FRACUNIT) - FRACUNIT
	elseif (not(p.xItemData.xItem_roulette >= (TICRATE*3))) then
		return
	end
	
	if (p.kartstuff[k_roulettetype] == 2) then -- Fake items
		p.kartstuff[k_eggmanexplode] = 4*TICRATE
		p.kartstuff[k_itemroulette] = 0
		p.xItemData.xItem_roulette = 0
		p.kartstuff[k_roulettetype] = 0
		S_StartSound(nil, sfx_itrole, p)
		return
	end
	
	if (xItemLib.cvars.dItemDebug.value ~= 0 and not modeattacking) then
		local di = xItemLib.cvars.dItemDebug.value > xItemLib.func.countItems() and xItemLib.func.countItems() or xItemLib.cvars.dItemDebug.value
		xItemLib.func.getItemResult(p, di)
		p.kartstuff[k_itemamount] = xItemLib.cvars.dItemDebugAmt.value
		p.kartstuff[k_itemblink] = TICRATE
		p.kartstuff[k_itemblinkmode] = 2
		p.kartstuff[k_itemroulette] = 0
		p.xItemData.xItem_roulette = 0
		p.kartstuff[k_roulettetype] = 0
		S_StartSound(nil, sfx_dbgsal, p)
		return
	end
	
	if (G_RaceGametype())
		spbrush = (spbplace ~= -1 and p.kartstuff[k_position] == spbplace+1)
	end
	
	--Split into another function for a debug function below
	useodds = xItemLib.func.findUseOdds(p, mashed, pingame, spbrush, dontforcespb)
	--print("got useodds "..useodds)
	
	for i = 1, xItemLib.func.countItems() do
		totalspawnchance = $ + xItemLib.func.getOdds(useodds, i, mashed, spbrush, p)
		spawnchance[i] = totalspawnchance
	end
	
	-- Award the player whatever power is rolled
	if (totalspawnchance > 0) then
		totalspawnchance = P_RandomKey(totalspawnchance)
		for i = 1, xItemLib.func.countItems() do
			if spawnchance[i] > totalspawnchance then 
				--print("GOT ITEM "..i)
				xItemLib.func.getItemResult(p, i)
				--custom on get functions
				if xItemLib.xItemData[i] and xItemLib.xItemData[i].getfunc then
					xItemLib.xItemData[i].getfunc(p, i)
				end
				break 
			end
		end
	else
		p.kartstuff[k_itemtype] = xItems.KITEM_SAD
		p.kartstuff[k_itemamount] = 1
	end
	
	S_StartSound(nil, ((p.kartstuff[k_roulettetype] == 1) and sfx_itrolk or (mashed and sfx_itrolm or sfx_itrolf)), p)
	
	p.kartstuff[k_itemblink] = TICRATE
	p.kartstuff[k_itemblinkmode] = ((p.kartstuff[k_roulettetype] == 1) and 2 or (mashed and 1 or 0))
	
	p.kartstuff[k_itemroulette] = 0
	p.xItemData.xItem_roulette = 0  --Since we're done, clear the roulette number
	p.kartstuff[k_roulettetype] = 0 --This too
end

local function canUseItem(p)
	return (p and p.mo and p.mo.health > 0 and (not p.spectator) and (not p.exiting)
		and p.kartstuff[k_spinouttimer] == 0 and p.kartstuff[k_squishedtimer] == 0 and p.kartstuff[k_respawn] == 0)
end

local function xItem_BasicItemHandler(p, cmd)
	local pdat = p.xItemData
	local kartstuff = p.kartstuff
	
	local attackDown = ((cmd.buttons & BT_ATTACK) and not (pdat.xItem_pressedUse))
	local noHyudoro = (p.kartstuff[k_stolentimer] == 0 and p.kartstuff[k_stealingtimer] == 0)

	if canUseItem(p) and kartstuff[k_itemtype] > 22 and attackDown and noHyudoro then
		--print("using item "..kartstuff[k_itemtype])
		if xItemLib.xItemData[kartstuff[k_itemtype]] and xItemLib.xItemData[kartstuff[k_itemtype]].usefunc then
			--print("has a function")
			pcall(xItemLib.xItemData[kartstuff[k_itemtype]].usefunc, p, cmd)
		else
			p.kartstuff[k_itemamount] = $-1
		end
	end
	
	if ((pdat.xItem_pressedUse) and not (cmd.buttons & BT_ATTACK)) then
		pdat.xItem_pressedUse = false
	elseif (cmd.buttons & BT_ATTACK) then
		pdat.xItem_pressedUse = true
	end
end


--port of item hud to lua
--now even more modular and extensible, and specifically made for xItemLib

local splitplayers = {}
local function splitnum(p)
	for i = 1, #splitplayers do
		if splitplayers[i] == p
			return i-1
		end
	end
end

local BASEVIDWIDTH  = 320
local BASEVIDHEIGHT = 200

local ITEM_X = 5
local ITEM_Y = 5

local ITEM1_X = -9
local ITEM1_Y = -8

local ITEM2_X = BASEVIDWIDTH-39
local ITEM2_Y = -8
local colormode = TC_RAINBOW
local localcolor = SKINCOLOR_NONE

local function xItem_DrawItem(v, p, c, i, blink)
	local fx = 0
	local fy = 0
	local fflags = 0
	local flipamount = false
	local offset = ((splitscreen > 1) and 2 or 1)
	
	local kp_itemx = v.cachePatch("K_ITX")
	local localbg = {v.cachePatch("K_ITBG"), v.cachePatch("K_ISBG")}
	local localmul = {v.cachePatch("K_ITMUL"), v.cachePatch("K_ISMUL")}
	local kp_itemtimer = {v.cachePatch("K_ITIMER"), v.cachePatch("K_ISIMER")}
	
	local colour = v.getColormap(p.mo and p.mo.skin or "sonic", SKINCOLOR_NONE)
	if i and p and xItemLib.xItemFlags[i] and (xItemLib.xItemFlags[i] & XIF_COLPATCH2PLAYER) then 
		colour = v.getColormap(p.mo and p.mo.skin or "sonic", p.skincolor)
	end
	
	if i == nil then
		i = p.kartstuff[k_itemtype]
	end
	
	local atics, get, icn
	if i > 0 then
		atics, get = xItemLib.func.getPatch(i, splitscreen >= 2)
		if atics then
			--print("item "..i.." is a table of patches")
			if xItemLib.xItemFlags[i] then
				--print("flags are "..xItemLib.xItemFlags[i])
			end
			if xItemLib.xItemFlags[i] and (xItemLib.xItemFlags[i] & XIF_ICONFORAMT) then 
				--print("item has XIF_ICONFORAMT")
				local idx = max(min(p.kartstuff[k_itemamount] or 1, table.maxn(get)), 1)
				icn = v.cachePatch(get[idx])
				--print("amount "..idx)
			else
				local idx = (leveltime/atics) % table.maxn(get)
				--print("item is an animation, drawing index "..idx + 1)
				icn = v.cachePatch(get[idx + 1])
			end
		else
			icn = v.cachePatch(get)
		end
	end
	if icn == nil then icn = v.cachePatch("K_ITSAD") end
	if p.xItemData.xItem_roulette then
		--print("spinning, drawing item "..i)
		colormode = TC_RAINBOW
		localcolor = p.skincolor or SKINCOLOR_GREY
		colour = v.getColormap(colormode, localcolor)
	end
	
	if p.kartstuff[k_itemblink] and leveltime%2 == 1 then
		colormode = TC_BLINK
		if p.kartstuff[k_itemblinkmode] == 2 then
			localcolor = 1 + (leveltime % (MAXSKINCOLORS-1))
		elseif p.kartstuff[k_itemblinkmode] == 1 then
			localcolor = SKINCOLOR_RED
		else
			localcolor = SKINCOLOR_WHITE
		end
		colour = v.getColormap(colormode, localcolor)
	end
	
	
	
	
	if splitscreen < 2 then -- don't change shit for THIS splitscreen.
		if c.pnum == 1 then
			fx = ITEM_X
			fy = ITEM_Y
			fflags = V_SNAPTOTOP|V_SNAPTOLEFT
		else
			fx = ITEM_X
			fy = ITEM_Y
			fflags = V_SNAPTOLEFT|V_SPLITSCREEN
		end
		
		v.drawScaled(fx<<FRACBITS, fy<<FRACBITS, FRACUNIT, localbg[1], V_HUDTRANS|fflags)
		
	else -- now we're having a fun game.
		if c.pnum == 1 or c.pnum == 3 then -- If we are P1 or P3...
			fx = ITEM1_X
			fy = ITEM1_Y
			fflags = (c.pnum == 3 and V_SPLITSCREEN or V_SNAPTOTOP)|V_SNAPTOLEFT	-- flip P3 to the bottom.	
		else -- else, that means we're P2 or P4.
			fx = ITEM2_X
			fy = ITEM2_Y
			fflags = (c.pnum == 4 and V_SPLITSCREEN or V_SNAPTOTOP)|V_SNAPTORIGHT
			flipamount = true
		end
		v.drawScaled(fx<<FRACBITS, fy<<FRACBITS, FRACUNIT, localbg[2], V_HUDTRANS|fflags)
		
	end
	
	
	--fuck me
	if p.kartstuff[k_itemamount] > 1 then
		v.draw(fx + (flipamount and 48 or 0), fy, localmul[offset], V_HUDTRANS|fflags|(flipamount and V_FLIP or 0))
		if (blink and leveltime % blink == 0) or (not blink) and blink ~= -1 then
			v.drawScaled(fx<<FRACBITS, fy<<FRACBITS, FRACUNIT, icn, V_HUDTRANS|fflags, colour)
		end
		if offset == 2 then
			if flipamount then	-- reminder that this is for 3/4p's right end of the screen.
				v.drawString(fx+2, fy+31, "x" + p.kartstuff[k_itemamount], V_ALLOWLOWERCASE|V_HUDTRANS|fflags)
			else
				v.drawString(fx+24, fy+31, "x" + p.kartstuff[k_itemamount], V_ALLOWLOWERCASE|V_HUDTRANS|fflags)
			end
		else
			v.draw(fy+28, fy+41, kp_itemx, V_HUDTRANS|fflags)
			v.drawKartString(fx+38, fy+36, p.kartstuff[k_itemamount], V_HUDTRANS|fflags)
		end
	else
		if (blink and leveltime % blink == 0) or (not blink) and blink ~= -1 then
			v.drawScaled(fx<<FRACBITS, fy<<FRACBITS, FRACUNIT, icn, V_HUDTRANS|fflags, colour)
		end
	end
	
	--timer bar
	local offset = 1
	local barlength = 26
	local height = 2
	local x = 11
	local y = 35
	if splitscreen > 1 then
		offset = 2
		barlength = 12
		height = 1
		x = 17
		y = 27
	end
	
	local itembar = p.xItemData.xItem_timerBar
	local maxitembar = p.xItemData.xItem_maxTimerBar
	
	if itembar > 0 then
		local fill = ((itembar*barlength)/maxitembar)
		local length = min(barlength, fill)
		
		v.draw(fx+x, fy+y, kp_itemtimer[offset], V_HUDTRANS|fflags)
		-- The left dark "AA" edge
		if length == 2 then
			v.drawFill(fx+x+1, fy+y+1, 2, height, 12|fflags)
		else
			v.drawFill(fx+x+1, fy+y+1, 1, height, 12|fflags)
		end
		-- The bar itself
		if (length > 2) then
			v.drawFill(fx+x+length, fy+y+1, 1, height, 12|fflags) -- the right one
			if (height == 2) then
				v.drawFill(fx+x+2, fy+y+2, length-2, 1, 8|fflags) -- the dulled underside
			end
			v.drawFill(fx+x+2, fy+y+1, length-2, 1, 120|fflags) -- the shine
		end
	end
end

--had a look at eggpanic to make sure this works clean with that too out of the box
local function xItem_drawEggTimer(v, p, c)
	local fx = 0
	local fy = 0
	local fflags = 0
	local flipamount = false
	local offset = ((splitscreen > 1) and 2 or 1)
	
	if splitscreen < 2 then -- don't change shit for THIS splitscreen.
		if c.pnum == 1 then
			fx = ITEM_X
			fy = ITEM_Y
			fflags = V_SNAPTOTOP|V_SNAPTOLEFT
		else
			fx = ITEM_X
			fy = ITEM_Y
			fflags = V_SNAPTOLEFT|V_SPLITSCREEN
		end
		v.draw(fx+17, fy+13, v.cachePatch("K_EGGN" .. G_TicsToSeconds(p.kartstuff[k_eggmanexplode])), fflags|V_HUDTRANS)
	else -- now we're having a fun game.
		if c.pnum == 1 or c.pnum == 3 then -- If we are P1 or P3...
			fx = ITEM1_X
			fy = ITEM1_Y
			fflags = (c.pnum == 3 and V_SPLITSCREEN or V_SNAPTOTOP)|V_SNAPTOLEFT	-- flip P3 to the bottom.	
		else -- else, that means we're P2 or P4.
			fx = ITEM2_X
			fy = ITEM2_Y
			fflags = (c.pnum == 4 and V_SPLITSCREEN or V_SNAPTOTOP)|V_SNAPTORIGHT
			flipamount = true
		end
		v.draw(fx+17, fy+13, v.cachePatch("K_EGGN" .. G_TicsToSeconds(p.kartstuff[k_eggmanexplode])), fflags|V_HUDTRANS)
	end
end



local function xItem_drawSad(v, p, c)
	local fx = 0
	local fy = 0
	local fflags = 0
	local flipamount = false
	local offset = ((splitscreen > 1) and 2 or 1)
	
	if splitscreen < 2 then -- don't change shit for THIS splitscreen.
		if c.pnum == 1 then
			fx = ITEM_X
			fy = ITEM_Y
			fflags = V_SNAPTOTOP|V_SNAPTOLEFT
		else
			fx = ITEM_X
			fy = ITEM_Y
			fflags = V_SNAPTOLEFT|V_SPLITSCREEN
		end
		v.draw(fx, fy, v.cachePatch("K_ITSAD"), fflags|V_HUDTRANS)
	else -- now we're having a fun game.
		if c.pnum == 1 or c.pnum == 3 then -- If we are P1 or P3...
			fx = ITEM1_X
			fy = ITEM1_Y
			fflags = (c.pnum == 3 and V_SPLITSCREEN or V_SNAPTOTOP)|V_SNAPTOLEFT	-- flip P3 to the bottom.	
		else -- else, that means we're P2 or P4.
			fx = ITEM2_X
			fy = ITEM2_Y
			fflags = (c.pnum == 4 and V_SPLITSCREEN or V_SNAPTOTOP)|V_SNAPTORIGHT
			flipamount = true
		end
		v.draw(fx, fy+13, v.cachePatch("K_ISSAD"), fflags|V_HUDTRANS)
	end
end

local function xItem_hudMain(v, p, c)
	if xItemLib.enableHud then
		hud.disable("item")
		splitplayers[#splitplayers+1] = p
		local kartstuff = p.kartstuff
		if p.xItemData then
			--handle vanilla special cases first
			if kartstuff[k_stolentimer] > 0 then
				xItemLib.func.hudDrawItem(v, p, c, xItems.KITEM_HYUDORO, 2)
			elseif kartstuff[k_stealingtimer] > 0 and leveltime % 2 then
				xItemLib.func.hudDrawItem(v, p, c, xItems.KITEM_HYUDORO)
			elseif kartstuff[k_eggmanexplode] then
				xItemLib.func.hudDrawItem(v, p, c, xItems.KITEM_EGGMAN, 2)
				xItemLib.func.hudDrawEgg(v, p, c)
			elseif kartstuff[k_rocketsneakertimer] then
				xItemLib.func.hudDrawItem(v, p, c, xItems.KITEM_ROCKETSNEAKER, 2)
				p.xItemData.xItem_timerBar = kartstuff[k_rocketsneakertimer]
				p.xItemData.xItem_maxTimerBar = 8*3*TICRATE
			elseif kartstuff[k_growshrinktimer] > 0 then
				xItemLib.func.hudDrawItem(v, p, c, xItems.KITEM_GROW, 2)
				if kartstuff[k_growcancel] > 0 then
					p.xItemData.xItem_timerBar = kartstuff[k_growcancel]
					p.xItemData.xItem_maxTimerBar = 26
				end
			elseif kartstuff[k_sadtimer] then
				xItemLib.func.hudDrawItem(v, p, c, 0, -1)
				if leveltime % 2 then
					xItemLib.func.hudDrawSad(v, p, c)
				end
			--custom item hud drawer here (this only runs when the item is still in the slot, if special timers are involved like above the mod should handle that by itself)
			elseif xItemLib.xItemData[kartstuff[k_itemtype]] and xItemLib.xItemData[kartstuff[k_itemtype]].hudfunc then
				pcall(xItemLib.xItemData[kartstuff[k_itemtype]].hudfunc, v, p, c)
			--draw the roulette
			elseif p.xItemData.xItem_roulette then
				xItemLib.func.hudDrawItem(v, p, c, ((leveltime/3) % table.maxn(xItemLib.xItemPatch)) + 1)
			--draw the held item
			elseif kartstuff[k_itemtype] then
				if kartstuff[k_itemheld] then
					xItemLib.func.hudDrawItem(v, p, c, kartstuff[k_itemtype], 2)
				else
					xItemLib.func.hudDrawItem(v, p, c)
				end
			end
		end
	else
		hud.enable("item")
	end
end



if not xItemLib then
	print("Initial xItemLib loading...")
	
	rawset(_G, "xItemLib", {
		gLibVersion = currLibVer,
		func = {},
		xItems = {},
		xItemNamespaces = {},
		xItemData = {}, --holds an item name, functions (on get (when rolled), on use, hud function), default raceodds, default battleodds
		xItemPatch = {}, --format is {{tics, bigpatch1, bigpatch2, ...}, {tics, smallpatch1, smallpatch2, ...}}
		xItemFlags = {},
		xItemFunctions = {},
		xItemOddsRace = {},
		xItemOddsBattle = {},
		cvars = {},
		enableHud = true
	})
	
	xItemLib.cvars.dItemDebug = CV_RegisterVar({ --equivalent to kartdebugitem
		name = "xitemdebugitem",
		defaultvalue = "0",
		flags = CV_NETVAR,
		possiblevalue = CV_Unsigned
	})
	xItemLib.cvars.dItemDebugAmt = CV_RegisterVar({ --equivalent to kartdebugitem
		name = "xitemdebugamount",
		defaultvalue = "1",
		flags = CV_NETVAR,
		possiblevalue = CV_Natural
	})

	local xItemFlags = {
		[xItems.KRITEM_DUALJAWZ] = XIF_POWERITEM,
		[xItems.KITEM_GROW] = XIF_POWERITEM|XIF_COOLDOWNONSTART,
		[xItems.KITEM_SHRINK] = XIF_POWERITEM|XIF_COOLDOWNONSTART|XIF_COOLDOWNINDIRECT,
		[xItems.KITEM_SPB] = XIF_COOLDOWNINDIRECT,
		[xItems.KITEM_THUNDERSHIELD] = XIF_POWERITEM|XIF_UNIQUE,
		[xItems.KITEM_HYUDORO] = XIF_COOLDOWNONSTART|XIF_UNIQUEANDUSED,
		[xItems.KITEM_ORBINAUT] = XIF_ICONFORAMT,
	}

	for i = -1, 22 do
		table.insert(xItemLib.xItems, i)
		if xItemFlags[i] then
			print("item "..i.." has flags "..xItemFlags[i])
			table.insert(xItemLib.xItemFlags, i, xItemFlags[i])
		end
		print("added item "..i.." to xItems")
		print(i.." items are loaded ("..table.maxn(xItemLib.xItemPatch).." patches)")
	end

	addItemPatch(xItems.KITEM_SAD, "K_ITSAD", "K_ISSAD")

	addItemPatch(xItems.KITEM_SNEAKER, "K_ITSHOE", "K_ISSHOE")
	addItemPatch(xItems.KITEM_ROCKETSNEAKER, "K_ITRSHE", "K_ISRSHE")
	addItemPatch(xItems.KITEM_INVINCIBILITY, {3, "K_ITINV1", "K_ITINV2", "K_ITINV3", "K_ITINV4", "K_ITINV5", "K_ITINV6", "K_ITINV7"}, {3, "K_ISINV1", "K_ISINV2", "K_ISINV3", "K_ISINV4", "K_ISINV5", "K_ISINV6"})
	addItemPatch(xItems.KITEM_BANANA, "K_ITBANA", "K_ISBANA")
	addItemPatch(xItems.KITEM_EGGMAN, "K_ITEGGM", "K_ISEGGM")
	addItemPatch(xItems.KITEM_ORBINAUT, {35, "K_ITORB1", "K_ITORB2", "K_ITORB3", "K_ITORB4"}, "K_ISORBN")
	addItemPatch(xItems.KITEM_JAWZ, "K_ITJAWZ", "K_ISJAWZ")
	addItemPatch(xItems.KITEM_MINE, "K_ITMINE", "K_ISMINE")
	addItemPatch(xItems.KITEM_BALLHOG, "K_ITBHOG", "K_ISBHOG")
	addItemPatch(xItems.KITEM_SPB, "K_ITSPB", "K_ISSPB")
	addItemPatch(xItems.KITEM_GROW, "K_ITGROW", "K_ISGROW")
	addItemPatch(xItems.KITEM_SHRINK, "K_ITSHRK", "K_ISSHRK")
	addItemPatch(xItems.KITEM_THUNDERSHIELD, "K_ITTHNS", "K_ISTHNS")
	addItemPatch(xItems.KITEM_HYUDORO, "K_ITHYUD", "K_ISHYUD")
	addItemPatch(xItems.KITEM_POGOSPRING, "K_ITPOGO", "K_ISPOGO")
	addItemPatch(xItems.KITEM_KITCHENSINK, "K_ITSINK", "K_ISSINK")

	--turns out I need these (TODO: have a way to disable items from showing on the roulette)
	addItemPatch(xItems.KRITEM_TRIPLESNEAKER, "K_ITSHOE", "K_ISSHOE")
	addItemPatch(xItems.KRITEM_TRIPLEBANANA, "K_ITBANA", "K_ISBANA")
	addItemPatch(xItems.KRITEM_TENFOLDBANANA, "K_ITBANA", "K_ISBANA")
	addItemPatch(xItems.KRITEM_TRIPLEORBINAUT, "K_ITORB3", "K_ISORBN")
	addItemPatch(xItems.KRITEM_QUADORBINAUT, "K_ITORB4", "K_ISORBN")
	addItemPatch(xItems.KRITEM_DUALJAWZ, "K_ITJAWZ", "K_ISJAWZ")

	--for custom items:
	--automatically allocate entries for new entries
	--extended items are namespaced XITEM_ (real item) or XRITEM_ (roulette-facing only)
	--maybe let users make their own namespaces? (eg, ELEM_ or DELI_)
	--same for any roulette facing entries as well (eg, if I were to make 3x Leafy Lasso as well as 1x Leafy Lasso, XITEM_ELEMBUKIGRASS *and* XRITEM_ELEMBUKIGRASS_3 would be allocated)
	--roulette facing items would be subfixed with _number

	--item odds
	--now here is where we can have some fun
	--instead of having a global itemodds table, we just pass itemodds tables to a ported getItemOdds function
	--this can allow for context-sensitive itemodds (character exclusivity, events such as Senpai Cannon, etc.)
	--mods could store itemodds tables in any userdata and just pass em (eg. I would store an elem exclusive itemodds table in a player struct running as elem, and pass that table along when an item spin is called)
	--when mods add items, have an option to let the item be appended to the existing global item table (and maybe even add an option for removing the item entry)
	--non-existant entries should be treated as only 0 odds for all places

	--item odd table definition style
	--basegame item odds
	--this is somehow better formatted than what KK has in (v1) source did someone fuck it up there kek
	--quick notes:
	--0 seems to be freeplay, 9 seems to be forced SPB, we may wanna not touch those?
	--total odds adds up to the how much the odds for that faux position is (in vanilla is generally 20, since there are 20 allocated items, but can be more or less than that)
	--base formula is (p-odds / totalOdds) wow that makes my life kinda easy here huh
	--getting the final item would just be P_RandomKey(totalOdds) and finding in which interval that value is
	local KK_itemOddsRace = {
		--P-Odds
		-- >: faux position (this is what mashing / karma touches)
		-- \/: p-odds (see base formula)
		--0  1  2  3  4  5  6  7  8  9
		{20, 0, 0, 4, 6, 7, 0, 0, 0, 0 }, -- Sneaker
		{ 0, 0, 0, 0, 0, 1, 4, 5, 3, 0 }, -- Rocket Sneaker
		{ 0, 0, 0, 0, 0, 1, 4, 6,10, 0 }, -- Invincibility
		{ 0, 9, 4, 2, 1, 0, 0, 0, 0, 0 }, -- Banana
		{ 0, 3, 2, 1, 0, 0, 0, 0, 0, 0 }, -- Eggman Monitor
		{ 0, 7, 6, 4, 2, 0, 0, 0, 0, 0 }, -- Orbinaut
		{ 0, 0, 3, 2, 1, 1, 0, 0, 0, 0 }, -- Jawz
		{ 0, 0, 2, 2, 1, 0, 0, 0, 0, 0 }, -- Mine
		{ 0, 0, 0, 2, 1, 0, 0, 0, 0, 0 }, -- Ballhog
		{ 0, 0, 1, 2, 3, 4, 2, 2, 0,20 }, -- Self-Propelled Bomb
		{ 0, 0, 0, 0, 0, 0, 2, 5, 7, 0 }, -- Grow
		{ 0, 0, 0, 0, 0, 0, 0, 2, 0, 0 }, -- Shrink
		{ 0, 1, 2, 0, 0, 0, 0, 0, 0, 0 }, -- Thunder Shield
		{ 0, 0, 0, 0, 1, 2, 1, 0, 0, 0 }, -- Hyudoro
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, -- Pogo Spring
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, -- Kitchen Sink
		{ 0, 0, 0, 0, 3, 7, 9, 2, 0, 0 }, -- Sneaker x3
		{ 0, 0, 1, 1, 0, 0, 0, 0, 0, 0 }, -- Banana x3
		{ 0, 0, 0, 0, 1, 0, 0, 0, 0, 0 }, -- Banana x10
		{ 0, 0, 0, 1, 0, 0, 0, 0, 0, 0 }, -- Orbinaut x3
		{ 0, 0, 0, 0, 1, 1, 0, 0, 0, 0 }, -- Orbinaut x4
		{ 0, 0, 0, 1, 2, 0, 0, 0, 0, 0 }  -- Jawz x2
	}

	--battle odds
	--!opinion!
	--why aren't these winning / losing based it was fine before smh
	--notes:
	--same story as in race but faux position is now just karma or not karma
	--karma total odds is 10 and not 20, so seems like totalOdds here would be 10
	local KK_itemOddsBattle = {
		--P-Odds
		-- >: normal or karma
		-- \/: p-odds (see base formula)
		--0  1
		{ 2, 1 }, -- Sneaker
		{ 0, 0 }, -- Rocket Sneaker
		{ 2, 1 }, -- Invincibility
		{ 1, 0 }, -- Banana
		{ 1, 0 }, -- Eggman Monitor
		{ 8, 0 }, -- Orbinaut
		{ 8, 1 }, -- Jawz
		{ 4, 1 }, -- Mine
		{ 2, 1 }, -- Ballhog
		{ 0, 0 }, -- Self-Propelled Bomb
		{ 2, 1 }, -- Grow
		{ 0, 0 }, -- Shrink
		{ 0, 0 }, -- Thunder Shield
		{ 2, 0 }, -- Hyudoro
		{ 2, 0 }, -- Pogo Spring
		{ 0, 0 }, -- Kitchen Sink
		{ 0, 1 }, -- Sneaker x3
		{ 1, 0 }, -- Banana x3
		{ 0, 1 }, -- Banana x10
		{ 2, 0 }, -- Orbinaut x3
		{ 1, 1 }, -- Orbinaut x4
		{ 2, 1 }  -- Jawz x2
	}

	for i = 1, #KK_itemOddsRace do
		table.insert(xItemLib.xItemOddsRace, KK_itemOddsRace[i])
	end
	for i = 1, #KK_itemOddsBattle do
		table.insert(xItemLib.xItemOddsBattle, KK_itemOddsBattle[i])
	end
	
	xItemLib.func.countItems = getLoadedItemAmount
	xItemLib.func.setPatch = addItemPatch
	xItemLib.func.getPatch = getItemPatch
	xItemLib.func.addItem = addXItem
	xItemLib.func.resetItemOdds = resetOddsForItem
	xItemLib.func.getPlayerScaling = playerScaling
	xItemLib.func.getStartCountdown = checkStartCooldown
	xItemLib.func.getPowerOdds = checkPowerItemOdds
	xItemLib.func.floatingItemThinker = floatingItemThinker
	xItemLib.func.getItemResult = xItem_GetItemResult
	xItemLib.func.getOdds = xItem_GetOdds
	xItemLib.func.setupDist = setupDistTable
	xItemLib.func.findUseOdds = xItem_FindUseOdds
	xItemLib.func.doRoulette = xItem_ItemRoulette
	xItemLib.func.attackHandler = xItem_BasicItemHandler
	xItemLib.func.hudDrawItem = xItem_DrawItem
	xItemLib.func.hudDrawEgg = xItem_drawEggTimer
	xItemLib.func.hudDrawSad = xItem_drawSad
	xItemLib.func.hudMain = xItem_hudMain

	hud.add(function(v, p, c)
		xItemLib.func.hudMain(v, p, c)
	end, "game")
	
	addHook("ThinkFrame", do
		for p in players.iterate do
			if not p.xItemData then
				p.xItemData = {
					xItem_roulette = 0,
					xItem_rouletteType = 0,
					xItem_blink = 0,
					xItem_blinkMode = 0,
					xItem_timerBar = 0,
					xItem_maxTimerBar = 0,
					
					xItem_raceOdds = xItemLib.xItemOddsRace,
					xItem_battleOdds = xItemLib.xItemOddsBattle,
					
					xItem_pressedUse = false
				}
			else
				p.xItemData.xItem_timerBar = 0
				p.xItemData.xItem_maxTimerBar = 0
			end
			xItemLib.func.attackHandler(p, p.cmd)
			xItemLib.func.doRoulette(p, p.cmd)
		end
	end)

	--dropped item behaviour
	addHook("MobjThinker", xItemLib.func.floatingItemThinker, MT_FLOATINGITEM)

	addHook("TouchSpecial", function(s, t)
		if t.player and t.player.xItemData and t.player.xItemData.xItem_roulette then
			return true
		end
	end, MT_FLOATINGITEM)

	addHook("TouchSpecial", function(s, t)
		if t.player and t.player.xItemData and t.player.xItemData.xItem_roulette then
			return true
		end
	end, MT_RANDOMITEM)
end

if xItemLib.gLibVersion < currLibVer then
	print("Updating xItemLib to lib version "..currLibVer)
	xItemLib.func.countItems = getLoadedItemAmount
	xItemLib.func.setPatch = addItemPatch
	xItemLib.func.getPatch = getItemPatch
	xItemLib.func.addItem = addXItem
	xItemLib.func.resetItemOdds = resetOddsForItem
	xItemLib.func.getPlayerScaling = playerScaling
	xItemLib.func.getStartCountdown = checkStartCooldown
	xItemLib.func.getPowerOdds = checkPowerItemOdds
	xItemLib.func.floatingItemThinker = floatingItemThinker
	xItemLib.func.getItemResult = xItem_GetItemResult
	xItemLib.func.getOdds = xItem_GetOdds
	xItemLib.func.setupDist = setupDistTable
	xItemLib.func.findUseOdds = xItem_FindUseOdds
	xItemLib.func.doRoulette = xItem_ItemRoulette
	xItemLib.func.attackHandler = xItem_BasicItemHandler
	xItemLib.func.hudDrawItem = xItem_DrawItem
	xItemLib.func.hudDrawEgg = xItem_drawEggTimer
	xItemLib.func.hudDrawSad = xItem_drawSad
	xItemLib.func.hudMain = xItem_hudMain
else
	print("xItemLib is to date")
end